/*
 *  Database class for DPAP sharing
 *
 *  Copyright (C) 2008 W. Michael Petullo <mike@flyn.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef __DMAPD_DPAP_DB
#define __DMAPD_DPAP_DB

#include <libdmapsharing/dpap-db.h>

G_BEGIN_DECLS

#define TYPE_DMAPD_DPAP_DB         (dmapd_dpap_db_get_type ())
#define DMAPD_DPAP_DB(o)           (G_TYPE_CHECK_INSTANCE_CAST ((o), TYPE_DMAPD_DPAP_DB, DmapdDPAPDb))
#define DMAPD_DPAP_DB_CLASS(k)     (G_TYPE_CHECK_CLASS_CAST((k), TYPE_DMAPD_DPAP_DB, DmapdDPAPDbClass))
#define IS_DMAPD_DPAP_DB(o)        (G_TYPE_CHECK_INSTANCE_TYPE ((o), TYPE_DMAPD_DPAP_DB))
#define IS_DMAPD_DPAP_DB_CLASS (k) (G_TYPE_CHECK_CLASS_TYPE ((k), TYPE_DMAPD_DPAP_DB_CLASS))
#define DMAPD_DPAP_DB_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), TYPE_DMAPD_DPAP_DB, DmapdDPAPDbClass))
#define DMAPD_DPAP_DB_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_DMAPD_DPAP_DB, DmapdDPAPDbPrivate))

typedef struct DmapdDPAPDbPrivate DmapdDPAPDbPrivate;

typedef struct {
	GObject parent;
	DmapdDPAPDbPrivate *priv;
} DmapdDPAPDb;

typedef struct {
	GObjectClass parent;
} DmapdDPAPDbClass;

DmapdDPAPDb *dmapd_dpap_db_new (void);
GType dmapd_dpap_db_get_type (void);

DPAPRecord *dmapd_dpap_db_lookup_by_id     (DPAPDb *db, gint id);
void dmapd_dpap_db_foreach_by_type  (DPAPDb *db, gpointer type, void (*fn) (DPAPRecord *record, gpointer data), gpointer data);
gint64 dmapd_dpap_db_count_by_type    (DPAPDb *db, gpointer type);
void dmapd_dpap_db_add (DPAPDb *db, DPAPRecord *record);

#endif /* __DMAPD_DPAP_DB */

G_END_DECLS
